package it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator;

import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.controller.CalculatorController;
import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.handlers.ControllerHandlerFactory;
import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.logging.ModelEventLogger;
import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.model.CalculatorModel;
import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.view.CalculatorGUI;

public class CalculatorMain {

	public static void main(String[] args) {
		// CalculatorModel implementa la logica
		CalculatorModel model = new CalculatorModel(ModelEventLogger.getInstance());

    CalculatorController controller = new CalculatorController(model);
    
    ControllerHandlerFactory controllerHandlerFactory = 
        new ControllerHandlerFactory(controller);
		
    CalculatorGUI gui = new CalculatorGUI(controllerHandlerFactory);
    
    controller.setView(gui);
    
		// Observer Design Pattern: la gui si registra al modello
		model.addView(gui); 
	}

}
