package it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.controller;

import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.model.CalculatorModel;
import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.model.Operation;
import it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.view.CalculatorView;

public class CalculatorController {

  private final CalculatorModel model;
  private CalculatorView view;
  
  public CalculatorController(CalculatorModel model) {
    if (model == null)
      throw new IllegalArgumentException("model cannot be null in the controller");
    
    this.model = model;
  }

  public void compute() {
    this.model.compute();
  }

  public void setCurrentOperation(Operation operation) {
    this.model.setCurrentOperation(operation);
  }

  public void reset() {
    this.model.reset();
  }

  public void pressDigit() {
    String rep = this.view.getOperandRepresentation();
    Double val = Double.valueOf(rep);
    this.model.setOperand(val);
  }

  public void setView(CalculatorView view) {
    this.view = view;
  }
}
