package it.polimi.dei.esercitazioniIngegneriaDelSoftware.swing.calculator.model;

/**
 * Evento che rappresenta l'avvenuto calcolo di una operazione.
 * @author andrea
 *
 */
public class CalculatorResultEvent implements CalculatorModelEvent {

  private final double result;
  
  /**
   * Crea un nuovo evento che rappresenta l'avvenuto calcolo di una
   * operazione.
   * @param result il risultato del calcolo.
   */
  CalculatorResultEvent(double result) {
    this.result = result;
  }
  
  /**
   * Restituisce il risultato del calcolo associato a questo evento.
   * @return il risultato del calcolo.
   */
  public double getResult() {
    return this.result;
  }
  
  @Override
  public String representation() {
    return "ResultEvent: new result is " + 
      String.valueOf(this.result);
  }

}
